;;-----------------------------LICENSE NOTICE------------------------------------
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;;	RENDER SYSTEM
;;
.include "cpctelera.h.s"


rendersys_init::
    ret

;; INPUT
;; IX: Pointer to first entity to render
;; A: Number of entities to render

render_update_borrado_nivel::
ret
;  ld de, (nivelActual)
;  ld a, (de) ;numEnemigos
;  ld ix, (nivelActual)
;   inc ix
; _renloop:
;        push    af
;
;        ;; Calculate a video-memory location for printing a string
;        ld  de, #0xC000 ;; DE = Pointer to start of the screen
;        ld  c, e_x(ix) ;; x
;        ld  b, e_y(ix) ;; y
;        call cpct_getScreenPtr_asm  ;; Calculate video memory location
;
;        ex  de, hl
;        ld  a, #0x00
;        ld  c, e_w(ix)
;        ld  b, e_h(ix)
;        call cpct_drawSolidBox_asm
;
;        pop af
;
;        dec a
;
;        ret z
;        cp #2
;        jr nz, sirsempertiranis
;
;         call entityman_getEntityArray_IX
;       jr _renloop
;        
;         sirsempertiranis:
;
;        ld  bc, #sizeof_e
;        add ix, bc
;       
;        jr  _renloop

render_update_dibujado::

  ld de, (nivelActual)
  ld a, (de) ;numEnemigos
 ld ix, (nivelActual)
   inc ix

 _renloopd:
        push    af

        ;; Calculate a video-memory location for printing a string
        ld  de, #0xC000 ;; DE = Pointer to start of the screen
        ld  c, e_x(ix) ;; x
        ld  b, e_y(ix) ;; y
        call cpct_getScreenPtr_asm  ;; Calculate video memory location

        ex  de, hl
        ld a, e_pspr(ix)
        inc a
        ld e_pspr(ix), a
        sub a, #1
        jr nz, sprite2
        ld l,e_spr(ix)
        ld h,e_spr+1(ix)
        jr NorestartSPR
        sprite2:
        ld l,e_spra(ix)
        ld h,e_spra+1(ix)
        ld e_pspr(ix),#0
        NorestartSPR:
        ld  c, e_w(ix) ;; x
        inc c
        ld  b, e_h(ix) ;; y
        inc b
        call cpct_drawSprite_asm

        pop af

        dec a
        ret z
        cp #2
        jr nz, moritutietsaluti

         call entityman_getEntityArray_IX
         jr _renloopd

          moritutietsaluti:
        ld  bc, #sizeof_e
        add ix, bc
        jr  _renloopd

 ;call updateScore

   drawMenu::
 ;Hay que poner la funcion en otro sitio
   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #6 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Titulo
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posTitleX)
   ld c, a ;CoordenadaX
   ld a, (posTitleY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #title
   call cpct_drawStringM0_asm

   ;Pinta Start
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posStartX)
   ld c, a ;CoordenadaX
   ld a, (posStartY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ;ex de, hl
   ld iy, #start
   call cpct_drawStringM0_asm

   ;Pinta Controles
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posControlsX)
   ld c, a ;CoordenadaX
   ld a, (posControlsY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #controls
   call cpct_drawStringM0_asm


   ;Pinta cuadrado de seleccion
   ld a, (menuSelection)
   dec a
   jr z, menuSelectionIs0

      menuSelectionIsNot0:
      ld hl, #posControlsX
      jr EndSeleccionMenuIs

      menuSelectionIs0:
      ld hl, #posStartX

   EndSeleccionMenuIs:

   ld de, #0xC000 ;Punto de referencia
   ;ld hl, #posStartX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #15 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado

ret

;Pinta unas lineas en la linea superior e inferior de la pantalla, las cuales van cambiando de color
drawMenuLines::

   ;Intercambio los colores
   ld a, (colorMenu1)
   ld b, a ;Guardo el color1
   ld a, (colorMenu2)
   ld c, a ;Guardo el color2
   ld (colorMenu1), a ;Meto el color2 en el 1
   ld a, b
   ld (colorMenu2), a ;Meto el color1 en el 2


   ;Pinta la linea superior del menu
   ld hl, #0xC000
   ld a, #40
   ;.rept #40
   loopms:
      push af
      ld a, (colorMenu1)
      ld (hl), a
      inc hl
      ld a, (colorMenu2)
      ld (hl), a
      inc hl
      pop af
      dec a
      jr nz, loopms
   ;.endm

   ;Pinta la linea inferior del menu
   ld hl, #0xFF80
   ;.rept #40
   ld a, #40
   loopmi:
      push af
      ld a, (colorMenu1)
      ld (hl), a
      inc hl
      ld a, (colorMenu2)
      ld (hl), a
      inc hl
      pop af
      dec a
      jr nz, loopmi

ret


clearScreenBlue:: ;Hay que poner la funcion en otro sitio

   ;Macro que limpia la pantalla, se le pasa el color
   cpctm_clearScreen_asm #0

ret

;Borra la seleccion
eraseMenuSelection::
   ld de, #0xC000 ;Punto de referencia
   ld hl, #posStartX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #0x00 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado


   ld de, #0xC000 ;Punto de referencia
   ld hl, #posControlsX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #0x00 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado

ret

;Borra la seleccion
eraseGameOverSelection::
   ld de, #0xC000 ;Punto de referencia
   ld hl, #posTryAgainX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #0x00 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado


   ld de, #0xC000 ;Punto de referencia
   ld hl, #posBackToMenuX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #0x00 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado

ret

;Pinta varios Strings que explican los controles
drawControls::

   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #6 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Control1
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posTitleControlsX)
   ld c, a ;CoordenadaX
   ld a, (posTitleControlsY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #titleControls
   call cpct_drawStringM0_asm


   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #9 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Control1
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posControl1X)
   ld c, a ;CoordenadaX
   ld a, (posControl1Y)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #control1
   call cpct_drawStringM0_asm

   ;Pinta Control2
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posControl2X)
   ld c, a ;CoordenadaX
   ld a, (posControl2Y)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #control2
   call cpct_drawStringM0_asm
ret

drawGameOver::

   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #2 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Control1
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posTitleGameOverX)
   ld c, a ;CoordenadaX
   ld a, (posTitleGameOverY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #stringTitleGameOver
   call cpct_drawStringM0_asm


   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #6 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Control1
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posTryAgainX)
   ld c, a ;CoordenadaX
   ld a, (posTryAgainY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #stringTryAgain
   call cpct_drawStringM0_asm

   ;Pinta Control1
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posBackToMenuX)
   ld c, a ;CoordenadaX
   ld a, (posBackToMenuY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #stringBackToMenu
   call cpct_drawStringM0_asm



   ;Pinta cuadrado de seleccion
   ld a, (gameOverSelection)
   dec a
   jr z, gameOverSelectionIs0

      gameOverSelectionIsNot0:
      ld hl, #posBackToMenuX
      jr EndgameOverSelectionIs

      gameOverSelectionIs0:
      ld hl, #posTryAgainX

   EndgameOverSelectionIs:

   ld de, #0xC000 ;Punto de referencia
   ;ld hl, #posStartX ;Carga direccion de x
   ld a, (hl) ;Carga contenido de x
   sub a, #3 ;Lo pongo un poco mas a la izquierda
   ld c, a
   inc hl ;Incrementa la direccion x, por lo que pasa a y
   ld b, (hl) ;Carga contenido de y
   call cpct_getScreenPtr_asm ;;Devuelve en hl la direccion de memoria

   ex de, hl ;pone la direccion anterior en de
   ld a, #15 ;elige el color
   ld bc, #0x0602 ;elige el tamanyo
   call cpct_drawSolidBox_asm ;llama a la funcion del cuadrado


ret

;updateScore::
;   ld hl, (timeCounter)
;   dec hl
;   ;Comprueba si h es 0
;   ld a, h
;   inc a
;   dec a
;   jr z, noCambiaSegundo
;      cambiaSegundo:
;         ;Ha pasado un segundo, reinicia el contador
;         ld hl, #60
;         ld (timeCounter), hl
;         ld a, (scoreValue1)
;         inc a
;         ;Comprueba si los segundos han llegado a 10
;         cp #58
;         jr nz, scoreValue1IsNot10
;            scoreValue1Is10:
;               ;Si es 10, lo reinicia a 0 y aumenta scoreValue2
;               ld a, (scoreValue2)
;               inc a
;               ld (scoreValue2), a
;               ld a, #48
;               ld (scoreValue1), a
;
;               ;Pinta scoreValue2
;               ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
;               ld a, (posScoreX)
;               add a, #12
;               ld c, a ;CoordenadaX
;               ld a, (posScoreY)
;               ld b, a ;CoordenadaY
;               call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria
;
;               ld a, (scoreValue2)
;               ld e, a
;               call cpct_drawCharM0_asm
;
;               jr endScoreValue10
;
;            scoreValue1IsNot10:
;
;            ld (scoreValue1), a ;Si no es 10 simplemente lo actualiza
;
;            endScoreValue10:
;
;         ;Pinta scoreValue1
;         ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
;         ld a, (posScoreX)
;         add a, #14
;         ld c, a ;CoordenadaX
;         ld a, (posScoreY)
;         ld b, a ;CoordenadaY
;         call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria
;
;         ld a, (scoreValue1)
;         ld e, a
;         call cpct_drawCharM0_asm
;
;         jr endCambiaSegundo
;
;      noCambiaSegundo:
;         ld (timeCounter), hl
;      endCambiaSegundo:
;
;ret

;drawScore::
;
;   ;Elige el color
;   ld h, #0 ;Color de fondo
;   ld l, #3 ;Color principal
;   call cpct_setDrawCharM0_asm
;
;   ;Pinta Titulo
;   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
;   ld a, (posScoreX)
;   ld c, a ;CoordenadaX
;   ld a, (posScoreY)
;   ld b, a ;CoordenadaY
;   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria
;
;   ld iy, #score
;   call cpct_drawStringM0_asm
;
;ret

;Actualiza las variables nivelValue1 y nivelValue2. Sirven para mostrar el numNivel con dos cifras
updateIndicadorNivel::
   ld a, (numNivel)
   ld b, #0
   loopSegundaCifraNivel:
   sub #10
   jr c, noAumentaSegundaCifra
   aumentaSegundaCifra:
      inc b
      jr loopSegundaCifraNivel
   noAumentaSegundaCifra:

   add #58 ;Le sumo 10 por la resta de antes y 48 por el ASCII
   ld (nivelValue2), a
   ld a, b
   add #48
   ld (nivelValue1), a

ret

;Dibuja arriba a la izquierda "Nivel: 01"
drawNivelEnJuego::
   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #15 ;Color principal
   call cpct_setDrawCharM0_asm
   ;Pinta Titulo
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posNivelX)
   ld c, a ;CoordenadaX
   ld a, (posNivelY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria
   ld iy, #stringNivel
   call cpct_drawStringM0_asm


   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posNivelX)
   add a, #26
   ld c, a
   ld a, (posNivelY)
   ld b, a
   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria

   call updateIndicadorNivel

   ld a, (nivelValue1)
   ld e, a
   call cpct_drawCharM0_asm 


   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posNivelX)
   add a, #30
   ld c, a
   ld a, (posNivelY)
   ld b, a
   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria

   ld a, (nivelValue2)
   ld e, a
   call cpct_drawCharM0_asm 

ret

changeStateToMenu::
   ld a, #02
   ld (gameState), a

   call synchronize
   call synchronize
   call synchronize
   call synchronize
   call synchronize
   call synchronize
   call synchronize
   
   call clearScreenBlue
   call drawMenu

ret

changeStateToGameOver::
   ld a, #4
   ld (gameState), a
   call clearScreenBlue
   call drawGameOver

ret

changeStateToControls::
   ld a, #3
   ld (gameState), a
   call clearScreenBlue
   call drawControls

ret

synchronize::
   halt
   halt
   call cpct_waitVSYNC_asm
   halt
   halt
ret

;Parametros:
;ld a, (#numNivel)
;
;Descripcion: actualiza la variable nivelActual usando numNivel y nivelArray
updateCurrentLevel::

   ld hl, #nivelArray
   ld de, #nivelActual

   loopNivelArray:
   dec a
   jr z, numNivelEs0
   numNivelNoEs0:
      inc hl
      inc hl
      jr loopNivelArray
   numNivelEs0:
      ld a, (hl)
      ld (de), a
      inc hl
      inc de
      ld a, (hl)
      ld (de), a
      dec de
ret

;Actualiza e imprime en el centro de la pantalla los valores nivelValue1 y nivelValue2
updateSeleccionNivel::

   ld h, #0 ;Color de fondo
   ld l, #9 ;Color principal
   call cpct_setDrawCharM0_asm
   
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posSeleccionDeNivelX)
   ;add a, #26
   ld c, a
   ld a, (posSeleccionDeNivelY)
   ld b, a
   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria

   call updateIndicadorNivel

   ld a, (nivelValue1)
   ld e, a
   call cpct_drawCharM0_asm 


   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posSeleccionDeNivelX)
   add a, #4
   ld c, a
   ld a, (posSeleccionDeNivelY)
   ld b, a
   call cpct_getScreenPtr_asm ;Devuelve en hl la direccion de memoria

   ld a, (nivelValue2)
   ld e, a
   call cpct_drawCharM0_asm 
ret

;Pinta el String "Select a level" y llama a updateSeleccionNivel
drawSeleccionNivel::
   ld h, #0 ;Color de fondo
   ld l, #6 ;Color principal
   call cpct_setDrawCharM0_asm

   ;Pinta Titulo
   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posTituloSeleccionDeNivelX)
   ld c, a ;CoordenadaX
   ld a, (posTituloSeleccionDeNivelY)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #tituloSeleccionDeNivel
   call cpct_drawStringM0_asm

   call updateSeleccionNivel

ret

;Incrementa la variable numNivel teniendo en cuenta el limite almacenado en maxNivel
incNumNivel::
   ld a, (maxNivel)
   inc a
   ld b, a
   ld a, (numNivel)
   inc a
   cp a, b
   jr nz, numNivelNoEsMax

   numNivelEsMax:
      dec b
      ld a, b
   numNivelNoEsMax:

   ld (numNivel), a
ret

;Decrementa la variable numNivel teniendo en cuenta el limite de 1
decNumNivel::
   ld a, (numNivel)
   dec a
   jr nz, decNumNivelNoEs0
   decNumNivelEs0:
      ld a, #1
   decNumNivelNoEs0:
   ld (numNivel), a
ret

;Input: A-Color. B-CoordenadaY
;ld a, #0xFF
;ld b, #170
drawHorizontalLine::

   push af

   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, #0
   ld c, a ;CoordenadaX
   ;ld a, #13
   ;ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   pop af

   ld d, #80
   loopDrawHorizontalLine:
   dec d
   ld (hl), a
   inc hl
   jr nz, loopDrawHorizontalLine
ret

drawYouWin::
   ;Elige el color
   ld h, #0 ;Color de fondo
   ld l, #6 ;Color principal
   call cpct_setDrawCharM0_asm

   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posYouWin1X)
   ld c, a ;CoordenadaX
   ld a, (posYouWin1Y)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #stringYouWin1
   call cpct_drawStringM0_asm

   ld de, #CPCT_VMEM_START_ASM ;Punto de referencia
   ld a, (posYouWin2X)
   ld c, a ;CoordenadaX
   ld a, (posYouWin2Y)
   ld b, a ;CoordenadaY
   call cpct_getScreenPtr_asm

   ld iy, #stringYouWin2
   call cpct_drawStringM0_asm
ret